from Tkinter import *
import tkMessageBox

def displayDescription( name, top ):
    tkMessageBox.showinfo( name, names[ name ], parent = top )

def descriptions():
    global names
    names = dict()
    names[ "Color Chooser" ] = """There are two different user selectable colors
that do various jobs. In general, the primary color is for
lines/border and the secondary is for fills (if applicable)."""
    names[ "Thickness Bar" ] = """The thickness slider determines the width
of lines as well as the thickness of borders."""
    names[ "Eraser" ] = """The eraser is a free form drag tool that turns a
region white."""
    names[ "Brush" ] = """The primary brush is a free form brush controlled
by the mouse. Ends are circles and in between is connecting
lines."""
    descriptions2()

def descriptions2():
    global names
    names[ "Eyedrop (Color Picker)" ] = """The eyedropper can select a color
from the active image and make it one of the usable colors.
Left mouse click sets it to the primary color, right click
to the secondary color."""
    names[ "Flood Fill" ] = """Flood Fill turns a region of equal color to
primary color."""
    names[ "Straight Line" ] = """Straight Line creates a line from where the
mouse is clicked to where it is released."""
    names[ "Rectangle" ] = """Rectangle creates a line from where the mouse is
clicked to where it is released."""
    names[ "Oval" ] = """Oval creates a line from where the mouse is clicked to
where it is released."""
    names[ "Free Polygon" ] = """Free Polygon is initiated with a left click.
The user then drags the mouse and a temporary line is shown.
A right click sets a new point as a vertex. Releasing the
left button creates the shape. Borders are not supported."""

def buttons( top ):
    tmp = Button( top, text = "Color Chooser",
                  command = lambda: displayDescription( "Color Chooser", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Thickness Bar",
                  command = lambda: displayDescription( "Thickness Bar", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Eraser",
                  command = lambda: displayDescription( "Eraser", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Brush",
                  command = lambda: displayDescription( "Brush", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Eyedrop (Color Picker)",
                  command = lambda: displayDescription(
            "Eyedrop (Color Picker)", top ) )
    tmp.pack( side = TOP )
    buttons2( top )

def buttons2( top ):
    tmp = Button( top, text = "Flood Fill",
                  command = lambda: displayDescription( "Flood Fill", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Straight Line",
                  command = lambda: displayDescription( "Straight Line", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Rectangle",
                  command = lambda: displayDescription( "Rectangle", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Oval",
                  command = lambda: displayDescription( "Oval", top ) )
    tmp.pack( side = TOP )
    tmp = Button( top, text = "Free Polygon",
                  command = lambda: displayDescription( "Free Polygon", top ) )
    tmp.pack( side = TOP )

def run( root ):
    top = Toplevel( root )
    top.title( "Function Overview" )
    functions = [ "Color Chooser", "Thickness Bar", "Eraser", "Brush",
                  "Eyedrop (Color Picker)", "Flood Fill", "Straight Line",
                  "Rectangle", "Oval", "Free Polygon" ]
    descriptions()
    buttons( top )
    
    button = Button(top, text="Dismiss", command=top.destroy)
    button.pack()
